"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = dragAddNode;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _g = require("@antv/g6");
var _graph = require("../util/graph");
var _clazz = require("../util/clazz");
function dragAddNode() {
  (0, _g.registerBehavior)('dragAddNode', {
    getEvents: function getEvents() {
      return {
        'canvas:mouseup': 'onMouseUp'
      };
    },
    onMouseUp: function onMouseUp(e) {
      var graph = this.graph;
      if (graph.get('onDragAddNode')) {
        var wrap = graph.get('container');
        var rect = wrap.getBoundingClientRect();

        // 坐标在视图范围内
        if (rect.left <= e.clientX && rect.right >= e.clientX && rect.top <= e.clientY && rect.bottom >= e.clientY) {
          var _p = graph.getPointByClient(e.clientX, e.clientY);
          this.addNode(_p);
        }
      }
    },
    addNode: function addNode(p) {
      var graph = this.graph;
      if (graph.get('onDragAddNode')) {
        var addModel = graph.get('addModel');
        var shouldAddNode = graph.get('shouldAddNode');
        if (shouldAddNode && !shouldAddNode(graph, addModel)) {
          return;
        }
        var id = (0, _graph.uniqIdByDate)((0, _clazz.getNodePrefix)(addModel.clazz));
        var x = p.x,
          y = p.y;
        var size = addModel.size.split('*').map(Number);
        var model = (0, _extends2["default"])({}, addModel, {
          x: x,
          y: y,
          size: size,
          id: id
        });
        var beforeAddNode = graph.get('beforeAddNode');
        beforeAddNode && beforeAddNode(graph, model);
        graph.add('node', model, true);
        graph.set('onDragAddNode', false);
      }
    }
  });
}