"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = dragEdge;
var _g = require("@antv/g6");
function dragEdge() {
  (0, _g.registerBehavior)('dragEdge', {
    getEvents: function getEvents() {
      return {
        'edge-anchor:dragstart': 'onDragStart',
        'edge-anchor:drag': 'onDrag'
      };
    },
    onDragStart: function onDragStart(e) {
      var _e$item;
      var model = (_e$item = e.item) === null || _e$item === void 0 ? void 0 : _e$item.getModel();
      this.origin = {
        x: e.x,
        y: e.y,
        offset: model.offset || 15,
        sourceAnchor: model.sourceAnchor,
        targetAnchor: model.targetAnchor
      };
    },
    onDrag: function onDrag(e) {
      var _this$origin = this.origin,
        x = _this$origin.x,
        y = _this$origin.y,
        offset = _this$origin.offset,
        sourceAnchor = _this$origin.sourceAnchor,
        targetAnchor = _this$origin.targetAnchor;
      var offsetX = Math.abs(e.x - x);
      var offsetY = Math.abs(e.y - y);
      var moveDis = 0;
      if (offsetX > offsetY) {
        moveDis = e.x - x;
      } else {
        moveDis = e.y - y;
      }

      // 锚点在左侧，移动距离为负数 是增加
      if (sourceAnchor === 3 || targetAnchor === 3 || sourceAnchor === 0 && targetAnchor === 0) {
        moveDis = -moveDis;
      }
      this.graph.update(e.item, {
        offset: Math.max(15, offset + moveDis)
      });
    }
  });
}