"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = hoverItem;
var _g = require("@antv/g6");
function hoverItem() {
  (0, _g.registerBehavior)('hoverItem', {
    getEvents: function getEvents() {
      return {
        'node:mouseenter': 'onNodeEnter',
        'node:mouseover': 'onNodeEnter',
        'node:mouseleave': 'onNodeLeave',
        'edge:mouseenter': 'onEdgeEnter',
        'edge:mouseover': 'onEdgeEnter',
        'edge:mouseleave': 'onEdgeLeave'
      };
    },
    onNodeEnter: function onNodeEnter(_ref) {
      var item = _ref.item;
      if (!this.graph.get('onDragEdge')) {
        this.graph.setItemState(item, 'show-anchor', true);
      }
    },
    onNodeLeave: function onNodeLeave(e) {
      if (!this.graph.get('onDragEdge')) {
        this.graph.setItemState(e.item, 'show-anchor', false);
      }
    },
    onEdgeEnter: function onEdgeEnter(e) {
      var _e$item;
      var states = (_e$item = e.item) === null || _e$item === void 0 ? void 0 : _e$item.get('states');
      if (states.includes('selected')) return;
      this.graph.setItemState(e.item, 'hover', true);
    },
    onEdgeLeave: function onEdgeLeave(e) {
      var _e$item2;
      var states = (_e$item2 = e.item) === null || _e$item2 === void 0 ? void 0 : _e$item2.get('states');
      if (states.includes('selected')) return;
      this.graph.setItemState(e.item, 'hover', false);
    }
  });
}