"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _base = _interopRequireDefault(require("./base"));
var _clazz = require("../util/clazz");
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var ghost;
var getGhost = function getGhost() {
  if (!ghost) {
    ghost = document.createElement('div');
    ghost.style.cssText = "position:fixed;bottom:100%;";
    document.body.append(ghost);
  }
  return ghost;
};
var StencilPlugin = /*#__PURE__*/function (_PluginBase) {
  (0, _inherits2["default"])(StencilPlugin, _PluginBase);
  var _super = _createSuper(StencilPlugin);
  function StencilPlugin() {
    var _this;
    (0, _classCallCheck2["default"])(this, StencilPlugin);
    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }
    _this = _super.call.apply(_super, [this].concat(args));
    _this.handleDragStart = function (e) {
      var graph = _this.get('graph');
      var target = e.target;
      var data = target.getAttribute('data-item');
      if (data) {
        var addModel = new Function('return ' + data)();
        var rect = target.getBoundingClientRect();
        var delegate = getGhost();
        delegate.innerHTML = target.outerHTML;
        e && e.dataTransfer && e.dataTransfer.setDragImage(delegate, rect.width / 2, rect.height / 2);
        graph.set('onDragAddNode', true);
        graph.set('addModel', (0, _extends2["default"])({}, addModel, {
          type: (0, _clazz.getShapeName)(addModel.clazz)
        }));
      }
    };
    _this.handleDragEnd = function (e) {
      console.log('drag end');
      var graph = _this.get('graph');
      graph.emit('canvas:mouseup', e);
      graph.set('onDragAddNode', false);
      graph.set('addModel', null);
      ghost ? ghost.innerHTML = '' : '';
    };
    return _this;
  }
  (0, _createClass2["default"])(StencilPlugin, [{
    key: "init",
    value: function init() {
      var container = this.get('container');
      container.addEventListener('dragstart', this.handleDragStart);
      container.addEventListener('dragend', this.handleDragEnd);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var container = this.get('container');
      container.removeEventListener('dragstart', this.handleDragStart);
      container.removeEventListener('dragend', this.handleDragEnd);
      if (ghost) {
        document.body.removeChild(ghost);
        ghost = null;
      }
    }
  }]);
  return StencilPlugin;
}(_base["default"]);
exports["default"] = StencilPlugin;