"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));
var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));
var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));
var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));
var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));
var _util = require("@antv/util");
var _base = _interopRequireDefault(require("./base"));
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2["default"])(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2["default"])(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2["default"])(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
var enableCommandMap = {
  redo: function redo(graph) {
    var redoStack = graph.getRedoStack();
    return redoStack && redoStack.length > 0;
  },
  undo: function undo(graph) {
    var undoStack = graph.getUndoStack();
    return undoStack && undoStack.length > 0;
  },
  "delete": function _delete(graph) {
    var mode = graph.getCurrentMode();
    var selectedItem = graph.get('selectedItem');
    return mode === 'edit' && !!selectedItem;
  },
  copy: function copy(graph) {
    var mode = graph.getCurrentMode();
    var selectedItem = graph.get('selectedItem');
    return mode === 'edit' && !!selectedItem;
  },
  zoomOut: function zoomOut() {
    return true;
  },
  zoomIn: function zoomIn() {
    return true;
  },
  autoFit: function autoFit() {
    return true;
  },
  resetZoom: function resetZoom() {
    return true;
  }
};
var Toolbar = /*#__PURE__*/function (_PluginBase) {
  (0, _inherits2["default"])(Toolbar, _PluginBase);
  var _super = _createSuper(Toolbar);
  function Toolbar() {
    (0, _classCallCheck2["default"])(this, Toolbar);
    return _super.apply(this, arguments);
  }
  (0, _createClass2["default"])(Toolbar, [{
    key: "init",
    value: function init() {
      this.initEvents();
      this.updateToolbar();
    }
  }, {
    key: "getEvents",
    value: function getEvents() {
      return {
        afterItemSelected: 'updateToolbar',
        afterCommandExecute: 'updateToolbar'
      };
    }
  }, {
    key: "initEvents",
    value: function initEvents() {
      var graph = this.get('graph');
      var parentNode = this.get('container');
      parentNode.addEventListener('click', function (e) {
        var target = e.target;
        while (target && target.getAttribute('data-command') === null) {
          target = target.parentElement;
        }
        if (target) {
          var command = target.getAttribute('data-command');
          graph.emit('executeCommand', command);
        }
      });
    }
  }, {
    key: "updateToolbar",
    value: function updateToolbar() {
      var _this = this;
      var graph = this.get('graph');
      var parentNode = this.get('container');
      var children = parentNode.querySelectorAll('button[data-command]');
      var commands = [];
      (0, _util.each)(children, function (child) {
        var command = child.getAttribute('data-command');
        if (_this.enableCommand(command)) {
          commands.push(command);
        }
      });
      graph.emit('updateToolbar', commands);
    }
  }, {
    key: "enableCommand",
    value: function enableCommand(command) {
      var graph = this.get('graph');
      return enableCommandMap[command](graph);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var container = this.get('container');
      container.parentNode.removeChild(container);
    }
  }]);
  return Toolbar;
}(_base["default"]);
exports["default"] = Toolbar;