"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.isUndefined = exports.isType = exports.isString = exports.isNumber = exports.isEmpty = void 0;
var toString = Object.prototype.toString;
var isType = function isType(type) {
  return function (obj) {
    return toString.call(obj) === "[object ".concat(type, "]");
  };
};
exports.isType = isType;
var isString = isType('String');
exports.isString = isString;
var isUndefined = isType('Undefined');
exports.isUndefined = isUndefined;
var isNumber = isType('Number');
exports.isNumber = isNumber;
var isEmpty = function isEmpty(obj) {
  return isUndefined(obj) || obj === null || obj === '';
};
exports.isEmpty = isEmpty;