import _classCallCheck from "@babel/runtime/helpers/esm/classCallCheck";
import _createClass from "@babel/runtime/helpers/esm/createClass";
import _inherits from "@babel/runtime/helpers/esm/inherits";
import _possibleConstructorReturn from "@babel/runtime/helpers/esm/possibleConstructorReturn";
import _getPrototypeOf from "@babel/runtime/helpers/esm/getPrototypeOf";
function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = _getPrototypeOf(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = _getPrototypeOf(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return _possibleConstructorReturn(this, result); }; }
function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }
import { each } from '@antv/util';
import PluginBase from "./base";
var enableCommandMap = {
  redo: function redo(graph) {
    var redoStack = graph.getRedoStack();
    return redoStack && redoStack.length > 0;
  },
  undo: function undo(graph) {
    var undoStack = graph.getUndoStack();
    return undoStack && undoStack.length > 0;
  },
  "delete": function _delete(graph) {
    var mode = graph.getCurrentMode();
    var selectedItem = graph.get('selectedItem');
    return mode === 'edit' && !!selectedItem;
  },
  copy: function copy(graph) {
    var mode = graph.getCurrentMode();
    var selectedItem = graph.get('selectedItem');
    return mode === 'edit' && !!selectedItem;
  },
  zoomOut: function zoomOut() {
    return true;
  },
  zoomIn: function zoomIn() {
    return true;
  },
  autoFit: function autoFit() {
    return true;
  },
  resetZoom: function resetZoom() {
    return true;
  }
};
var Toolbar = /*#__PURE__*/function (_PluginBase) {
  _inherits(Toolbar, _PluginBase);
  var _super = _createSuper(Toolbar);
  function Toolbar() {
    _classCallCheck(this, Toolbar);
    return _super.apply(this, arguments);
  }
  _createClass(Toolbar, [{
    key: "init",
    value: function init() {
      this.initEvents();
      this.updateToolbar();
    }
  }, {
    key: "getEvents",
    value: function getEvents() {
      return {
        afterItemSelected: 'updateToolbar',
        afterCommandExecute: 'updateToolbar'
      };
    }
  }, {
    key: "initEvents",
    value: function initEvents() {
      var graph = this.get('graph');
      var parentNode = this.get('container');
      parentNode.addEventListener('click', function (e) {
        var target = e.target;
        while (target && target.getAttribute('data-command') === null) {
          target = target.parentElement;
        }
        if (target) {
          var command = target.getAttribute('data-command');
          graph.emit('executeCommand', command);
        }
      });
    }
  }, {
    key: "updateToolbar",
    value: function updateToolbar() {
      var _this = this;
      var graph = this.get('graph');
      var parentNode = this.get('container');
      var children = parentNode.querySelectorAll('button[data-command]');
      var commands = [];
      each(children, function (child) {
        var command = child.getAttribute('data-command');
        if (_this.enableCommand(command)) {
          commands.push(command);
        }
      });
      graph.emit('updateToolbar', commands);
    }
  }, {
    key: "enableCommand",
    value: function enableCommand(command) {
      var graph = this.get('graph');
      return enableCommandMap[command](graph);
    }
  }, {
    key: "destroy",
    value: function destroy() {
      var container = this.get('container');
      container.parentNode.removeChild(container);
    }
  }]);
  return Toolbar;
}(PluginBase);
export { Toolbar as default };