import _extends from "@babel/runtime/helpers/esm/extends";
import editorStyle from '../util/defaultStyle';
import { registerNode } from "@antv/g6";
var taskDefaultOptions = {
  style: _extends({}, editorStyle.nodeStyle, {
    fill: '#E7F7FE',
    stroke: '#1890FF',
    cursor: 'default'
  }),
  stateStyles: {
    selected: {
      fill: '#95D6FB'
    },
    hover: {
      cursor: editorStyle.cursor.hoverNode
    },
    needAlign: {
      stroke: '#f00',
      fillOpacity: 0.92
    }
  }
};
var startDefaultOptions = {
  style: _extends({}, editorStyle.nodeStyle, {
    fill: '#FEF7E8',
    stroke: '#FA8C16',
    cursor: 'default'
  }),
  stateStyles: {
    selected: {
      fill: '#FCD49A'
    },
    hover: {
      cursor: editorStyle.cursor.hoverNode
    },
    needAlign: {
      stroke: '#aeff18',
      fillOpacity: 0.92
    }
  }
};
var endDefaultOptions = {
  icon: null,
  iconStyle: {
    width: 18,
    height: 18,
    left: 6,
    top: 6
  },
  style: _extends({}, editorStyle.nodeStyle, {
    fill: '#EFF7E8',
    stroke: '#F5222D',
    cursor: 'default'
  }),
  stateStyles: {
    selected: {
      fill: '#CFD49A'
    },
    hover: {
      cursor: editorStyle.cursor.hoverNode
    },
    needAlign: {
      stroke: '#aeff18',
      fillOpacity: 0.92
    }
  }
};
function getShapeStyle(cfg) {
  var _cfg$style, _cfg$style2;
  if (cfg.size && cfg.size.length === 0) {
    cfg.size = [40, 40];
  }
  var options = this.options;
  var width = cfg.size[0];
  return _extends({
    x: 0,
    y: 0,
    r: width / 2
  }, options.style, {
    stroke: ((_cfg$style = cfg.style) === null || _cfg$style === void 0 ? void 0 : _cfg$style.stroke) || options.style.stroke,
    fill: ((_cfg$style2 = cfg.style) === null || _cfg$style2 === void 0 ? void 0 : _cfg$style2.fill) || options.style.fill
  });
}
export default function flowNode() {
  registerNode('normal-node', {
    shapeType: 'rect',
    options: _extends({}, taskDefaultOptions, {
      minSize: [90, 40]
    }),
    getShapeStyle: function getShapeStyle(cfg) {
      var _cfg$style3, _cfg$style4;
      if (cfg.size && cfg.size.length === 0) {
        cfg.size = [90, 40];
      }
      var options = this.options;
      var width = cfg.size[0];
      var height = cfg.size[1];
      return _extends({
        x: 0 - width / 2,
        y: 0 - height / 2,
        width: width,
        height: height
      }, options.style, {
        stroke: ((_cfg$style3 = cfg.style) === null || _cfg$style3 === void 0 ? void 0 : _cfg$style3.stroke) || options.style.stroke,
        fill: ((_cfg$style4 = cfg.style) === null || _cfg$style4 === void 0 ? void 0 : _cfg$style4.fill) || options.style.fill
      });
    }
  }, 'base-node');
  registerNode('parallel_sign-node', {
    shapeType: 'rect',
    options: _extends({}, taskDefaultOptions, {
      minSize: [90, 40]
    }),
    getShapeStyle: function getShapeStyle(cfg) {
      var _cfg$style5, _cfg$style6;
      if (cfg.size && cfg.size.length === 0) {
        cfg.size = [90, 40];
      }
      var options = this.options;
      var width = cfg.size[0];
      var height = cfg.size[1];
      return _extends({
        x: 0 - width / 2,
        y: 0 - height / 2,
        width: width,
        height: height
      }, options.style, {
        stroke: ((_cfg$style5 = cfg.style) === null || _cfg$style5 === void 0 ? void 0 : _cfg$style5.stroke) || options.style.stroke,
        fill: ((_cfg$style6 = cfg.style) === null || _cfg$style6 === void 0 ? void 0 : _cfg$style6.fill) || options.style.fill,
        radius: 0
      });
    }
  }, 'base-node');
  registerNode('serial_sign-node', {
    shapeType: 'rect',
    options: _extends({}, taskDefaultOptions, {
      minSize: [90, 40]
    }),
    getShapeStyle: function getShapeStyle(cfg) {
      var _cfg$style7, _cfg$style8;
      if (cfg.size && cfg.size.length === 0) {
        cfg.size = [90, 40];
      }
      var options = this.options;
      var width = cfg.size[0];
      var height = cfg.size[1];
      return _extends({
        x: 0 - width / 2,
        y: 0 - height / 2,
        width: width,
        height: height
      }, options.style, {
        stroke: ((_cfg$style7 = cfg.style) === null || _cfg$style7 === void 0 ? void 0 : _cfg$style7.stroke) || options.style.stroke,
        fill: ((_cfg$style8 = cfg.style) === null || _cfg$style8 === void 0 ? void 0 : _cfg$style8.fill) || options.style.fill,
        radius: 0
      });
    }
  }, 'base-node');
  registerNode('service-node', {
    shapeType: 'rect',
    options: _extends({}, taskDefaultOptions, {
      minSize: [90, 40]
    }),
    getShapeStyle: function getShapeStyle(cfg) {
      var _cfg$style9, _cfg$style10;
      if (cfg.size && cfg.size.length === 0) {
        cfg.size = [90, 40];
      }
      var options = this.options;
      var width = cfg.size[0];
      var height = cfg.size[1];
      return _extends({
        x: 0 - width / 2,
        y: 0 - height / 2,
        width: width,
        height: height
      }, options.style, {
        stroke: ((_cfg$style9 = cfg.style) === null || _cfg$style9 === void 0 ? void 0 : _cfg$style9.stroke) || options.style.stroke,
        fill: ((_cfg$style10 = cfg.style) === null || _cfg$style10 === void 0 ? void 0 : _cfg$style10.fill) || options.style.fill,
        radius: height / 2
      });
    }
  }, 'base-node');
  registerNode('start-node', {
    shapeType: 'circle',
    options: _extends({}, startDefaultOptions),
    getShapeStyle: getShapeStyle
  }, 'base-node');
  registerNode('end-node', {
    shapeType: 'circle',
    options: _extends({}, endDefaultOptions),
    getShapeStyle: getShapeStyle
  }, 'base-node');
}