import _typeof from "@babel/runtime/helpers/esm/typeof";
function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it["return"] != null) it["return"](); } finally { if (didErr) throw err; } } }; }
function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }
function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i]; return arr2; }
import { FILE_BUSI_TYPE } from '../constants';
import Expression from './expression';
var fieldValueType = {
  TableWidget: {
    backendFieldType: 'subForm',
    backendValueType: 'obj',
    frontType: 'spacial'
  },
  TabPage: {
    backendFieldType: 'tabForm',
    backendValueType: 'obj',
    frontType: 'spacial'
  },
  AttachList: {
    backendFieldType: 'AttachList',
    backendValueType: 'string',
    frontType: 'spacial'
  },
  TextInput: {
    backendFieldType: 'TextInput',
    backendValueType: 'string',
    frontType: 'string'
  },
  NumberInput: {
    backendFieldType: 'NumberInput',
    backendValueType: 'double',
    frontType: 'double'
  },
  TextArea: {
    backendFieldType: 'TextArea',
    backendValueType: 'obj',
    frontType: 'string'
  },
  RadioGroup: {
    backendFieldType: 'RadioGroup',
    backendValueType: 'string',
    frontType: 'string',
    "default": ''
  },
  CheckBoxGroup: {
    backendFieldType: 'CheckBoxGroup',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  SelectInput: {
    backendFieldType: 'SelectInput',
    backendValueType: 'string',
    frontType: 'string',
    "default": ''
  },
  MultiStageSelect: {
    backendFieldType: 'MultiStageSelect',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  SearchInput: {
    backendFieldType: 'SearchInput',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  DatePicker: {
    backendFieldType: 'DatePicker',
    backendValueType: 'date',
    frontType: 'double'
  },
  DateRangePicker: {
    backendFieldType: 'DateRangePicker',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  TimePicker: {
    backendFieldType: 'DatePicker',
    backendValueType: 'date',
    frontType: 'double'
  },
  TimeRangePicker: {
    backendFieldType: 'DateRangePicker',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  RichText: {
    backendFieldType: 'RichText',
    backendValueType: 'obj',
    frontType: 'string'
  },
  FileUpload: {
    backendFieldType: 'FileUpload',
    backendValueType: 'string',
    frontType: 'json',
    "default": ''
  },
  ImageShow: {
    backendFieldType: 'FileUpload',
    backendValueType: 'string',
    frontType: 'json',
    "default": ''
  },
  VideoShow: {
    backendFieldType: 'VideoShow',
    backendValueType: 'string',
    frontType: 'json',
    "default": ''
  },
  ChooseUser: {
    backendFieldType: 'ChooseUser',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  ChooseGroup: {
    backendFieldType: 'ChooseGroup',
    backendValueType: 'string',
    frontType: 'json',
    "default": function _default() {
      return [];
    }
  },
  HideInput: {
    backendFieldType: 'HideInput',
    backendValueType: 'string',
    frontType: 'string',
    "default": ''
  }
};
export function dfsTravelNode(list, cb) {
  var stack = [{
    children: list,
    root: true
  }];
  while (stack.length) {
    var top = stack.pop();
    var next = cb && cb(top);
    if (typeof next === "boolean" && !next) break;
    if (_typeof(next) === "object" && next.skip) continue;
    if (next) {
      if (top && top.children) {
        var len = top.children.length;
        for (var i = len - 1; i >= 0; i--) {
          stack.push(top.children[i]);
        }
      }
    }
  }
}
var FormUtil = {
  registerFieldType: function registerFieldType(type, config) {
    fieldValueType[type] = config;
  },
  getFieldTypeConfig: function getFieldTypeConfig(type) {
    return fieldValueType[type];
  },
  getValue: function getValue(e) {
    if (e && e.target) {
      return ['radio', 'checkbox'].includes(e.target.type) ? e.target.checked : e.target.value;
    }
    return e;
  },
  judgeRelativeField: function judgeRelativeField(data) {
    return this.setListInclude(data, 'relativeHideInput') && !!data.relativeField;
  },
  /**
   * 设置里面包含字段
   * @param data
   * @param key
   * @returns {boolean}
   */
  setListInclude: function setListInclude(data, key) {
    return !!(data && data.setList && data.setList.indexOf(key) >= 0);
  },
  // 处理tab 表单字段
  dealTabFormTemplateForDesign: function dealTabFormTemplateForDesign(tabPage) {
    var _this = this;
    var tabs = tabPage.tabStruct;
    var fieldList = [];
    tabs.forEach(function (tab) {
      var item = {
        fieldKey: tab.fieldKey,
        fieldName: tab.fieldName,
        fieldType: "childTabForm",
        tabFormList: tab.formList ? _this.dealFormTemplateForDesign(tab.formList) : []
      };
      fieldList.push(item);
    });
    return fieldList;
  },
  /**
   * 为设计页，处理待提交的表达式
   * @param exprObj
   * @returns {Array}
   */
  dealExprForDesign: function dealExprForDesign(exprObj) {
    var formComputeExprs = exprObj.formComputeExprs,
      formValidateExprs = exprObj.formValidateExprs;
    var formExprList = [];
    if (formComputeExprs && Array.isArray(formComputeExprs.exprList)) {
      formComputeExprs.exprList.forEach(function (item) {
        formExprList.push({
          errorPrompt: item.errorPrompt,
          expr: item.expr,
          exprType: 1,
          accuracy: formComputeExprs.accuracy
        });
      });
    }
    if (formValidateExprs && Array.isArray(formValidateExprs.exprList)) {
      formValidateExprs.exprList.forEach(function (item) {
        formExprList.push({
          errorPrompt: item.errorPrompt,
          expr: item.expr,
          exprType: 2,
          accuracy: formValidateExprs.accuracy
        });
      });
    }
    return formExprList;
  },
  /**
   * 为提交处理表单模板
   * @param formList
   * @returns {Array}
   */
  dealFormTemplateForDesign: function dealFormTemplateForDesign(formList) {
    var arr = [];
    dfsTravelNode(formList, function (i) {
      var fieldConfig = i.type && fieldValueType[i.type];
      if (typeof i.fieldKey !== 'undefined' && fieldConfig) {
        var _item = {};
        _item.appNeeded = Array.isArray(i.setList) && i.setList.indexOf('app') >= 0 ? 1 : 2;
        _item.isVariable = Array.isArray(i.setList) && i.setList.indexOf('processVar') >= 0 ? 1 : 2;
        _item.isTitle = Array.isArray(i.setList) && i.setList.indexOf('isTitle') >= 0 ? 1 : 2;
        _item.needHide = Array.isArray(i.setList) && i.setList.indexOf('hidden') >= 0 ? 1 : 2;
        _item.isPriority = Array.isArray(i.setList) && i.setList.indexOf('isPriority') >= 0 ? 1 : 2;
        _item.fieldKey = i.fieldKey;
        _item.fieldName = i.fieldName;
        _item.dataSourceId = i.dataSource || undefined;
        _item.fieldValueType = fieldConfig.backendValueType; // === "TableWidget" ? "obj" : "string";
        _item.fieldType = fieldConfig.backendFieldType;
        if (i.type === 'TableWidget') {
          _item.subformFieldList = i.tableHead && FormUtil.dealFormTemplateForDesign(i.tableHead);
        }
        if (i.type === 'TabPage') {
          _item.tabFormList = FormUtil.dealTabFormTemplateForDesign(i);
        }
        arr.push(_item);
      }
      return true;
    });
    return arr;
  },
  /**
   * 获取tab页的数据
   * @param tabs
   */
  getTabPageData: function getTabPageData(tabs) {
    var _this2 = this;
    var tabsData = {};
    tabs.forEach(function (tab) {
      tabsData[tab.fieldKey] = _this2.getFormDataByFormList(tab.formList);
    });
    return tabsData;
  },
  /**
   * 从formList中，返回纯formData
   * @param formList
   * @returns formData { Object }
   */
  getFormDataByFormList: function getFormDataByFormList(formList) {
    var _this3 = this;
    var formData = {};
    formList.forEach(function (item) {
      if (typeof item.fieldKey !== 'undefined') {
        switch (item.type) {
          case 'NumberInput':
            formData[item.fieldKey] = item.fieldValue !== '' ? Number(item.fieldValue) : item.defaultValue;
            break;
          case 'TabPage':
            formData[item.fieldKey] = _this3.getTabPageData(item.tabStruct);
            break;
          default:
            formData[item.fieldKey] = item.fieldValue !== '' ? item.fieldValue : item.defaultValue || item.fieldValue;
            break;
        }
      }
    });
    return formData;
  },
  getFormDataByFormObj: function getFormDataByFormObj(formObj) {
    var obj = {};
    Object.keys(formObj).forEach(function (key) {
      obj[key] = formObj[key].value;
    });
    return obj;
  },
  /**
   * @param {Date} date
   * @param formatStr
   * @returns {string}
   */
  dateToStr: function dateToStr(date) {
    var formatStr = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'yyyy-MM-dd';
    var str = formatStr;
    str = str.replace(/yyyy|YYYY/, date.getFullYear() + '');
    str = str.replace(/yy|YY/, date.getFullYear() % 100 > 9 ? (date.getFullYear() % 100).toString() : "0".concat(date.getFullYear() % 100));
    str = str.replace(/MM/, date.getMonth() > 8 ? (date.getMonth() + 1).toString() : "0".concat(date.getMonth() + 1));
    str = str.replace(/M/g, date.getMonth() + 1 + '');
    str = str.replace(/dd|DD/, date.getDate() > 9 ? date.getDate().toString() : "0".concat(date.getDate()));
    str = str.replace(/[dD]/g, date.getDate() + '');
    str = str.replace(/hh|HH/, date.getHours() > 9 ? date.getHours().toString() : "0".concat(date.getHours()));
    str = str.replace(/[hH]/g, date.getHours() + '');
    str = str.replace(/mm/, date.getMinutes() > 9 ? date.getMinutes().toString() : "0".concat(date.getMinutes()));
    str = str.replace(/m/g, date.getMinutes() + '');
    str = str.replace(/ss|SS/, date.getSeconds() > 9 ? date.getSeconds().toString() : "0".concat(date.getSeconds()));
    str = str.replace(/[sS]/g, date.getSeconds() + '');
    str = str.replace(/AP/g, date.getHours() >= 12 ? '下午' : '上午');
    return str;
  },
  /**
   * 处理字段 显示/隐藏
   * @param itemAttr
   * @param scopes
   */
  judgeFormItemShowHide: function judgeFormItemShowHide(itemAttr, scopes) {
    var expr = itemAttr.hiddenExpression;
    var showHideFields = scopes.showHideFields;
    var hidden = this.setListInclude(itemAttr, 'hidden');
    if (hidden) {
      // 显示字段中没有
      hidden = showHideFields ? showHideFields.replace(/'/g, '').split(',').indexOf(itemAttr.fieldKey) < 0 : hidden;
      if (expr) {
        return !Expression.executeConditionExpr(expr, scopes);
      }
    }
    return hidden;
  },
  /**
   * 判断字段是否可以编辑，优先级从低到高依次
   * 1、页面可编辑
   * 2、流程设置可编辑字段
   * 3、表单设置表达式
   * @param itemAttr
   * @param scopes
   * @param disabled
   * @returns {*}
   */
  judgeFormItemCanEdit: function judgeFormItemCanEdit(itemAttr, scopes, disabled) {
    var expr = itemAttr.readonlyExpression;
    if (expr && this.setListInclude(itemAttr, 'readonly')) {
      // 结果非只读
      return Expression.executeConditionExpr(expr, scopes);
    }
    var editFields = scopes.editFields;
    return editFields ? editFields.split(',').indexOf(itemAttr.fieldKey) >= 0 : !disabled;
  },
  /**
   * 判断表单元素的表达式， 必填、只读、显示
   * @param itemAttr
   * @param key
   * @param scopes
   * @returns {*}
   */
  judgeFormItemExpr: function judgeFormItemExpr(itemAttr, key, scopes) {
    var expr = itemAttr["".concat(key, "Expression")];
    if (this.setListInclude(itemAttr, key) && expr) {
      // 结果为真 , 非必填、非只读、显示
      return !Expression.executeConditionExpr(expr, scopes);
    }
    return this.setListInclude(itemAttr, key);
  },
  /**
   * 校验表单模板的字段是否填写完整，是否重复
   * @param formList
   * @param cb
   */
  validateField: function validateField(formList, cb) {
    var keyArr = {};
    var hasError = false;
    dfsTravelNode(formList, function (item) {
      if (item.root) return true;
      if (!item.type) {
        hasError = true;
        cb(Error("\u8BF7\u9009\u62E9\u8868\u5355\u9879\u7684\u5B57\u6BB5\u7C7B\u578B"), item);
        return false;
      }
      if (!item.fieldName || item.fieldName.trim() === '') {
        hasError = true;
        cb(Error("\u8BF7\u586B\u5199\u8868\u5355\u9879\u7684\u5B57\u6BB5\u540D\u79F0"), item);
        return false;
      }
      if ('fieldKey' in item && !item.fieldKey) {
        hasError = true;
        cb(Error("\u8BF7\u586B\u5199\u201C".concat(item.fieldName, "\u201D\u7684\u5B57\u6BB5key")), item);
        return false;
      } else if (item.fieldKey) {
        keyArr[item.fieldKey] = keyArr[item.fieldKey] ? keyArr[item.fieldKey] + 1 : 1;
      }
      if (item.type === 'TabPage') {
        var tabKey = {};
        try {
          item.tabStruct.forEach(function (tab, tIndex) {
            if (!tab.fieldName || tab.fieldName.trim() === '') {
              throw Error("\u8BF7\u586B\u5199\u6807\u7B7E\u9875, \u9875\u7B7E-".concat(tIndex + 1, " \u7684\u5B57\u6BB5\u540D\u79F0"));
            }
            if (!tab.fieldKey) {
              throw Error("\u8BF7\u586B\u5199\u6807\u7B7E\u9875, \u9875\u7B7E-".concat(tIndex + 1, " \u7684\u5B57\u6BB5key"));
            } else {
              tabKey[tab.fieldKey] = tabKey[tab.fieldKey] ? tabKey[tab.fieldKey] + 1 : 1;
            }
          });
        } catch (e) {
          hasError = true;
          cb(Error(e.message), item);
          return false;
        }
        var _str = [];
        Object.keys(tabKey).forEach(function (key) {
          if (tabKey[key] >= 2) {
            _str.push(key);
          }
        });
        if (_str.length > 0) {
          hasError = true;
          cb(Error("\u6807\u7B7E\u9875\u5B58\u5728\u91CD\u590D\u7684\u5B57\u6BB5key\uFF1A".concat(_str.join('；'))), item);
          return false;
        }
      }
      if (item.type === 'TableWidget' && item.tableHead.length === 0) {
        hasError = true;
        cb(Error("\u8868\u683C\u63A7\u4EF6\u8BF7\u8BBE\u7F6E\u8868\u7ED3\u6784"), item);
        return false;
      }
      return true;
    });
    if (hasError) {
      return;
    }
    var str = [];
    Object.keys(keyArr).forEach(function (key) {
      if (keyArr[key] >= 2) {
        str.push(key);
      }
    });
    if (str.length > 0) {
      cb(Error("\u5B58\u5728\u91CD\u590D\u7684\u5B57\u6BB5key\uFF1A".concat(str.join('；'))));
    } else {
      cb(true);
    }
  },
  /**
   * 根据配置生成高级查询的元素
   * @param config
   */
  generateAdvOptionItem: function generateAdvOptionItem(config) {
    var item;
    var upperKey = config.fieldKey.slice(0, 1).toUpperCase() + config.fieldKey.slice(1);
    switch (config.dataType) {
      case 'date':
        item = {
          text: config.fieldName,
          type: 'DateRangePicker',
          name: config.fieldKey,
          start: "start".concat(upperKey),
          end: "end".concat(upperKey)
        };
        break;
      case 'number':
        item = {
          text: config.fieldName,
          type: 'NumberRange',
          name: config.fieldKey,
          min: "min".concat(upperKey),
          max: "max".concat(upperKey)
        };
        break;
      case 'amount':
        item = {
          text: config.fieldName,
          type: 'NumberRange',
          name: config.fieldKey,
          min: "min".concat(upperKey),
          max: "max".concat(upperKey)
        };
        break;
      case 'select':
        item = {
          text: config.fieldName,
          type: 'Select',
          name: config.fieldKey,
          options: config.options
        };
        break;
      default:
        item = {
          text: config.fieldName,
          type: 'Input',
          name: config.fieldKey
        };
    }
    return item;
  },
  booleanConvert: function booleanConvert(value) {
    if (typeof value === 'boolean') {
      return value;
    }
    if (typeof value === 'string') {
      return value === 'true';
    }
  },
  /**
   * 将表单实例对象, 设置到formList
   * @param formList
   * @param formData
   * @return formList {Object}
   */
  setFormListByFormData: function setFormListByFormData(formList, formData) {
    dfsTravelNode(formList, function (field) {
      if (typeof field.fieldKey !== 'undefined') {
        switch (field.type) {
          case 'TabPage':
            {
              var tabData = formData[field.fieldKey];
              field.tabStruct.forEach(function (tab) {
                var subFormData = tabData[tab.fieldKey];
                FormUtil.setFormListByFormData(tab.formList, subFormData);
              });
            }
            break;
          default:
            {
              field.fieldValue = formData[field.fieldKey];
            }
            break;
        }
      }
      return true;
    });
    return formList;
  },
  /**
   * 将表单实例字段列表, 设置到formList
   * @param formList
   * @param formInstList
   * @return formData {Object}
   */
  setFormListByFormInst: function setFormListByFormInst(formList, formInstList) {
    var _this4 = this;
    var flatFormList = [];
    dfsTravelNode(formList, function (field) {
      if (typeof field.fieldKey !== 'undefined') {
        flatFormList.push(field);
      }
      return true;
    });
    flatFormList.forEach(function (obj) {
      var field = formInstList.find(function (item) {
        return item.fieldKey === obj.fieldKey;
      });
      if (field) {
        obj.fieldInstId = field.fieldInstId;
        obj.fieldValueType = field.fieldValueType;
        var fieldConfig = fieldValueType[obj.type];
        if (obj.type === 'TableWidget') {
          obj.fieldValue = _this4.setTableWidgetBody(field.subFieldList, obj.tableHead);
        } else if (obj.type === 'TabPage') {
          _this4.setTabPageData(field.tabFormList, obj.tabStruct);
        } else {
          if (fieldConfig) {
            obj.fieldValue = _this4.setWidgetValue(field, fieldConfig);
          }
        }
      }
    });
    return formList.slice(0);
  },
  /**
   * 获取控件的值
   * @param item
   * @param fieldConfig
   * @return {*}
   */
  postWidgetValue: function postWidgetValue(item, fieldConfig) {
    switch (fieldConfig.frontType) {
      case "spacial":
        if (item.type === 'AttachList') {
          return JSON.stringify({
            busiType: FILE_BUSI_TYPE[item.busiType] || FILE_BUSI_TYPE.MAIN_ATTACH,
            fileInfo: item.fieldValue || []
          });
        }
        break;
      case "json":
        return JSON.stringify(item.fieldValue);
      default:
        return typeof item.fieldValue !== 'undefined' ? item.fieldValue : "";
    }
  },
  /**
   * 设置控件的值
   * @param item
   * @param fieldConfig
   * @return {*}
   */
  setWidgetValue: function setWidgetValue(item, fieldConfig) {
    switch (fieldConfig.frontType) {
      case "spacial":
        if (item.fieldType === 'AttachList') {
          try {
            return JSON.parse(item.fieldValue).fileInfo;
          } catch (e) {
            return [];
          }
        }
        break;
      case 'json':
        try {
          return JSON.parse(item.fieldValue) || fieldConfig["default"]();
        } catch (e) {
          return item.fieldValue || fieldConfig["default"]();
        }
      case 'double':
        return item.fieldValue === '' || !/^\d+$/.test(item.fieldValue) ? item.fieldValue : Number(item.fieldValue);
      default:
        return typeof item.fieldValue !== 'undefined' ? item.fieldValue : '';
    }
  },
  /**
   * 获取表格控件的字段数据
   * @param tableHead
   * @param tableBody
   */
  getTableBodyFieldList: function getTableBodyFieldList(tableHead, tableBody) {
    var _this5 = this;
    var arr = [];
    var sort = 0;
    tableBody.forEach(function (tr) {
      // console.log(tr);
      tableHead.forEach(function (th) {
        var fieldConfig = fieldValueType[th.type];
        console.log(fieldConfig);
        if (fieldConfig) {
          var _item2 = {};
          _item2.fieldInstId = tr['fieldInstId@' + th.fieldKey] || "";
          _item2.appNeeded = Array.isArray(th.setList) && th.setList.indexOf('app') >= 0 ? 1 : 2;
          _item2.needHide = Array.isArray(th.setList) && th.setList.indexOf('hidden') >= 0 ? 1 : 2;
          _item2.isVariable = Array.isArray(th.setList) && th.setList.indexOf('processVar') >= 0 ? 1 : 2;
          _item2.isPriority = Array.isArray(th.setList) && th.setList.indexOf('isPriority') >= 0 ? 1 : 2;
          _item2.fieldKey = th.fieldKey;
          _item2.fieldName = th.fieldName;
          _item2.fieldValue = tr[th.fieldKey];
          _item2.type = th.type;
          _item2.fieldValueType = fieldConfig.backendValueType;
          _item2.fieldType = fieldConfig.backendFieldType;
          _item2.required = Array.isArray(th.setList) && th.setList.indexOf('required') >= 0;
          _item2.sort = sort;
          _item2.fieldValue = _this5.postWidgetValue(_item2, fieldConfig);
          arr.push(_item2);
        }
      });
      sort++;
    });
    // console.log(arr);
    return arr;
  },
  /**
   * 设置表格控件的值
   * @param tableList
   * @param tableHead
   * @return {Array}
   */
  setTableWidgetBody: function setTableWidgetBody(tableList, tableHead) {
    var arr = [];
    var sort = 0;
    var count = tableList.length;
    var index = 0;
    var typeMap = tableHead.reduce(function (prev, cur) {
      prev[cur.fieldKey] = cur.type;
      return prev;
    }, {});
    console.log(typeMap);
    while (index < count) {
      // let row = [];
      var _field = {};
      var _iterator = _createForOfIteratorHelper(tableList),
        _step;
      try {
        for (_iterator.s(); !(_step = _iterator.n()).done;) {
          var obj = _step.value;
          var _item3 = JSON.parse(JSON.stringify(obj));
          if (_item3.sort === sort) {
            // console.log(item);
            _field[_item3.fieldKey] = this.setWidgetValue(_item3, fieldValueType[typeMap[_item3.fieldKey]]);
            _field["fieldInstId@".concat(_item3.fieldKey)] = _item3.fieldInstId;
          }
        }
      } catch (err) {
        _iterator.e(err);
      } finally {
        _iterator.f();
      }
      if (Object.keys(_field).length > 0) {
        arr.push(_field);
      }
      index++;
      sort++;
    }
    // console.log(arr);
    return arr;
  },
  /**
   * 设置tab页 数据
   * @param fieldList
   * @param destTabs
   */
  setTabPageData: function setTabPageData(fieldList, destTabs) {
    var _this6 = this;
    fieldList.forEach(function (field) {
      var tab = destTabs.find(function (item) {
        return item.fieldKey === field.fieldKey;
      });
      if (tab) {
        tab.fieldInstId = field.fieldInstId;
        tab.formList = _this6.setFormListByFormInst(tab.formList, field.tabFormList);
      }
    });
  },
  /**
   * 获取tab页的 字段数据
   * @param tabs
   * @returns {Array}
   */
  getTabPageFieldList: function getTabPageFieldList(tabs) {
    var _this7 = this;
    var tabsData = [];
    tabs.forEach(function (tab) {
      var item = {};
      item.fieldInstId = tab.fieldInstId || "";
      item.fieldKey = tab.fieldKey;
      item.fieldName = tab.fieldName;
      item.fieldValueType = 'obj';
      item.fieldType = "childTabForm";
      item.tabFormList = _this7.dealPostFieldList(tab.formList);
      tabsData.push(item);
    });
    return tabsData;
  },
  /**
   * 处理要提交的表单字段, 设置字段值,以及相关属性
   * @param formList
   * @return {Array} fieldList
   */
  dealPostFieldList: function dealPostFieldList(formList) {
    var _this8 = this;
    var fieldList = [];
    var judgeSetList = function judgeSetList(setList, key) {
      return Array.isArray(setList) && setList.indexOf(key) >= 0 ? 1 : 2;
    };
    dfsTravelNode(formList, function (i) {
      var fieldConfig = fieldValueType[i.type];
      if (fieldConfig) {
        var _item4 = {};
        _item4.fieldInstId = i.fieldInstId || '';
        _item4.appNeeded = judgeSetList(i.setList, 'app');
        _item4.needHide = judgeSetList(i.setList, 'hidden');
        _item4.isVariable = judgeSetList(i.setList, 'processVar');
        _item4.isTitle = judgeSetList(i.setList, 'isTitle');
        _item4.isPriority = judgeSetList(i.setList, 'isPriority');
        _item4.fieldKey = i.fieldKey;
        _item4.fieldName = i.fieldName;
        _item4.titlePostfix = i.titlePostfix ? i.titlePostfix : null;
        _item4.titlePretfix = i.titlePretfix ? i.titlePretfix : null;
        _item4.fieldValueType = i.fieldValueType || fieldConfig.backendValueType;
        _item4.fieldType = fieldConfig.backendFieldType;
        if (i.type === "TableWidget") {
          _item4.subFieldList = _this8.getTableBodyFieldList(i.tableHead, i.fieldValue || []);
        } else if (i.type === 'TabPage') {
          _item4.tabFormList = _this8.getTabPageFieldList(i.tabStruct);
        } else {
          _item4.fieldValue = _this8.postWidgetValue(i, fieldConfig);
        }
        fieldList.push(_item4);
      }
      return true;
    });
    return fieldList;
  },
  /**
   *获取需要关联的数据源列表,主要用于浏览框的单选
   * @param {Array} formList
   */
  getNeedRelateSourceList: function getNeedRelateSourceList(formList) {
    var arr = [];
    dfsTravelNode(formList, function (item) {
      if (typeof item.fieldKey !== 'undefined' && item.dataSource && Array.isArray(item.setList) && item.setList.indexOf('needRelated') >= 0) {
        arr.push({
          dataSourceId: item.dataSource,
          dataId: item.fieldValue[0].value
        });
      }
      return true;
    });
    return arr;
  },
  /**
   * 获取表单中，流程变量map;
   * @param formList
   */
  getProcessVariableMap: function getProcessVariableMap(formList) {
    var obj = {};
    dfsTravelNode(formList, function (field) {
      if (typeof field.fieldKey !== 'undefined' && Array.isArray(field.setList) && field.setList.indexOf('processVar') > -1) {
        obj[field.fieldKey] = field.fieldValue || field.defaultValue;
      }
      return true;
    });
    return obj;
  },
  formListGridRows: function formListGridRows(formList, scopes) {
    var rows = [];
    var currentRow = [];
    var i = 0,
      len = formList.length;
    while (i < len) {
      var current = formList[i];
      currentRow.push(current);
      var currentSpans = currentRow.reduce(function (total, cur) {
        return total + (cur.defaultSize || 24);
      }, 0);
      if (currentSpans === 24) {
        currentRow.forEach(function (item) {
          return item.hidden = FormUtil.judgeFormItemShowHide(item, scopes);
        });
        rows.push({
          row: currentRow,
          hidden: currentRow.every(function (item) {
            return item.hidden;
          })
        });
        currentRow = [];
        i++;
      } else if (currentSpans > 24) {
        currentRow.pop();
        currentRow.forEach(function (item) {
          return item.hidden = FormUtil.judgeFormItemShowHide(item, scopes);
        });
        rows.push({
          row: currentRow,
          hidden: currentRow.every(function (item) {
            return item.hidden;
          })
        });
        currentRow = [];
      } else if (i === len - 1 && currentSpans < 24) {
        currentRow.forEach(function (item) {
          return item.hidden = FormUtil.judgeFormItemShowHide(item, scopes);
        });
        rows.push({
          row: currentRow,
          hidden: currentRow.every(function (item) {
            return item.hidden;
          })
        });
        i++;
      } else {
        i++;
      }
    }
    return rows;
  }
};
export default FormUtil;