import { Graph, Item } from "@antv/g6";
import { Options, GraphData } from './interface';
export default class FlowDesigner {
    graph: Graph;
    container: HTMLElement;
    options: Options;
    private readonly events;
    private resizeTimer?;
    private selectedItemId?;
    private readonly wheelEnable?;
    private flowTypes?;
    private usedFlowTypes;
    private readonly defaultData;
    private readonly setDynamicData?;
    constructor(options: Options);
    init(options: Options): Graph;
    private __onWheel;
    private __resizeFunc;
    initEvent(): void;
    clearSelected(): void;
    updateEdge(item: Item, value: any): void;
    update(key: any, cfg: any): void;
    initData(data?: GraphData, dynamicTasks?: any, options?: Partial<Options>): void;
    save(needValid?: boolean): {
        tasks: {};
        flows: {};
    } | null | undefined;
    getData(): {
        tasks: {};
        flows: {};
    } | null | undefined;
    validate(data: any): boolean;
    focusElement(item: any, info: any): void;
    destroy(): void;
}
