import { Graph } from '@antv/g6';
export interface IPluginBaseConfig {
    container?: HTMLDivElement | string | null;
    className?: string;
    graph?: Graph;
    [key: string]: any;
}
export default abstract class PluginBase {
    private _events;
    _cfgs: IPluginBaseConfig;
    destroyed: boolean;
    constructor(cfgs?: IPluginBaseConfig);
    getDefaultCfgs(): {};
    initPlugin(graph: Graph): void;
    abstract init(): any;
    getEvents(): {};
    get(key: string): any;
    set(key: string, val: any): void;
    destroy(): void;
    destroyPlugin(): void;
}
