import { Clazz, FlowEdge, FlowNode, GraphData } from '../interface';
export declare const FlowStatusColors: {
    '0': {
        stroke: string;
        fill: string;
    };
    '1': {
        stroke: string;
        fill: string;
    };
    '2': {
        stroke: string;
        fill: string;
    };
};
export declare const defaultData: {
    nodes: ({
        clazz: string;
        size: number[];
        label: string;
        shape: string;
        type: string;
        x: number;
        y: number;
        id: string;
        defCategory: string;
        defKey: string;
        defName: string;
        userChooseType: string;
        userChooseMethod: string;
        roleIds: never[];
        groupId: number;
        nodeIdIndex: number;
        isProcFirst?: undefined;
    } | {
        clazz: string;
        size: number[];
        label: string;
        shape: string;
        type: string;
        x: number;
        y: number;
        id: string;
        defCategory: string;
        defKey: string;
        defName: string;
        userChooseType: string;
        userChooseMethod: string;
        roleIds: {}[];
        isProcFirst: boolean;
        groupId: number;
        nodeIdIndex: number;
    })[];
    edges: {
        clazz: string;
        source: string;
        target: string;
        sourceTaskDefKey: string;
        tarTaskDefKey: string;
        sourceAnchor: number;
        id: string;
        targetAnchor: number;
        shape: string;
        type: string;
        flowName: string;
        startPoint: {
            x: number;
            y: number;
            index: number;
        };
        endPoint: {
            x: number;
            y: number;
            index: number;
        };
        lineIdIndex: number;
    }[];
};
export declare function getNodeSize(clazz: Clazz, node: any): number[];
export declare function getPointPosition(type: any, node: any): {
    x: any;
    y: any;
    index: number;
};
export declare function dealFlowData(data: GraphData, flowTypes: any, usedFlowTypes: any, dynamicTasks: any, setDynamicData: any): {
    nodes: ({
        clazz: string;
        size: number[];
        label: string;
        shape: string;
        type: string;
        x: number;
        y: number;
        id: string;
        defCategory: string;
        defKey: string;
        defName: string;
        userChooseType: string;
        userChooseMethod: string;
        roleIds: never[];
        groupId: number;
        nodeIdIndex: number;
        isProcFirst?: undefined;
    } | {
        clazz: string;
        size: number[];
        label: string;
        shape: string;
        type: string;
        x: number;
        y: number;
        id: string;
        defCategory: string;
        defKey: string;
        defName: string;
        userChooseType: string;
        userChooseMethod: string;
        roleIds: {}[];
        isProcFirst: boolean;
        groupId: number;
        nodeIdIndex: number;
    })[];
    edges: {
        clazz: string;
        source: string;
        target: string;
        sourceTaskDefKey: string;
        tarTaskDefKey: string;
        sourceAnchor: number;
        id: string;
        targetAnchor: number;
        shape: string;
        type: string;
        flowName: string;
        startPoint: {
            x: number;
            y: number;
            index: number;
        };
        endPoint: {
            x: number;
            y: number;
            index: number;
        };
        lineIdIndex: number;
    }[];
} | {
    nodes: FlowNode[];
    edges: FlowEdge[];
};
