import { FormField } from '../interface';
interface IComputeExpr {
    computeExpr: string;
    resultKey: string;
    fullExpr: string;
    accuracy?: number;
}
interface IExprs {
    exprList: {
        expr: string;
    }[];
}
declare const Expression: {
    findFieldByKey(formList: FormField[], fieldKey: string): FormField | undefined;
    validateExprFieldInFormList(exprObj: any, formList: FormField[]): true | Error;
    validateExpression(expStr: string): true | Error;
    validateLogicExpr(logicExpr: string, formList: FormField[]): true | Error;
    compileExprStr(expr: string, scopeName: string): string;
    compileExprStrJudgeScope(expr: string, scopes: any): string | number;
    executeLogicExpr(logicExpr: string, formData: any, accuracy: number): any;
    executeConditionExpr(expr: string, scopes: any): boolean | string | number;
    executeValidateExpr(formValidateExprs: any, formData: any): string;
    countDateDiff(field: number[], type: string): number;
    computeStrategy(computeStr: string, formData: any): string;
    executeComputeExpr(exprObj: IComputeExpr, formData: any, scopes: any): any;
    splitComputeExpr(exprStr: string, trimWrapper?: boolean): string[];
    judgeComputeExprVariableHasValue(computeExpr: string, scopes: any): boolean;
    sortExprByFiledKey(exprList: {
        expr: string;
    }[], fieldKey: string): IComputeExpr[];
    bachExecuteComputeExpr(formComputeExprs: IExprs, fieldKey: string, formData: any, scopes: any): any;
    filterExpressionVariable(expr?: string): string[];
};
export default Expression;
