import { FormExprConfig, FormField } from '../interface';
interface FormEvent {
    target?: HTMLInputElement;
}
interface IFieldValueConfig {
    backendFieldType: string;
    backendValueType: 'obj' | 'double' | 'string' | 'long' | 'date';
    frontType: 'json' | 'string' | 'double' | 'spacial';
    default?: any;
}
export declare function dfsTravelNode(list: FormField[], cb: (item: FormField) => (boolean | {
    skip: Boolean;
})): void;
declare const FormUtil: {
    registerFieldType(type: any, config: IFieldValueConfig): void;
    getFieldTypeConfig(type: any): IFieldValueConfig;
    getValue(e: FormEvent): string | boolean;
    judgeRelativeField(data: FormField): boolean;
    setListInclude(data: FormField, key: string): boolean;
    dealTabFormTemplateForDesign(tabPage: any): FormField[];
    dealExprForDesign(exprObj: any): FormExprConfig[];
    dealFormTemplateForDesign(formList: FormField[]): FormField[];
    getTabPageData(tabs: {
        fieldKey: string;
        formList: FormField[];
    }[]): {};
    getFormDataByFormList(formList: FormField[]): {};
    getFormDataByFormObj(formObj: any): {};
    dateToStr(date: Date, formatStr?: string): string;
    judgeFormItemShowHide(itemAttr: any, scopes: any): boolean;
    judgeFormItemCanEdit(itemAttr: any, scopes: any, disabled: any): string | number | boolean;
    judgeFormItemExpr(itemAttr: any, key: any, scopes: any): boolean;
    validateField(formList: FormField[], cb: (result: boolean | Error, field?: FormField) => boolean): void;
    generateAdvOptionItem(config: any): any;
    booleanConvert(value: any): boolean | undefined;
    setFormListByFormData(formList: any, formData: any): any;
    setFormListByFormInst(formList: any, formInstList: any): any;
    postWidgetValue(item: any, fieldConfig: IFieldValueConfig): any;
    setWidgetValue(item: any, fieldConfig: IFieldValueConfig): any;
    getTableBodyFieldList(tableHead: any, tableBody: any): FormField[];
    setTableWidgetBody(tableList: any, tableHead: any): FormField[];
    setTabPageData(fieldList: any, destTabs: any): void;
    getTabPageFieldList(tabs: any): FormField[];
    dealPostFieldList(formList: any): FormField[];
    getNeedRelateSourceList(formList: any): {
        dataSourceId: string;
        dataId: string;
    }[];
    getProcessVariableMap(formList: any): {};
    formListGridRows(formList: FormField[], scopes: any): {
        row: FormField[];
        hidden: boolean;
    }[];
};
export default FormUtil;
