export interface TabStruct {
    fieldKey: string;
    fieldName: string;
    formList: FormField[];
    contentHeight: number | string;
}
export interface FormField {
    fieldKey?: string;
    fieldName?: string;
    fieldType?: string;
    tabFormList?: FormField[];
    formList?: FormField[];
    appNeeded?: 1 | 2;
    isVariable?: 1 | 2;
    isTitle?: 1 | 2;
    needHide?: 1 | 2;
    isPriority?: 1 | 2;
    dataSource?: string;
    dataSourceId?: string;
    defaultSize?: 8 | 12 | 24;
    fieldValueType?: string;
    subFieldList?: FormField[];
    subformFieldList?: FormField[];
    fieldInstId?: string;
    fieldValue?: any;
    type?: string;
    sort?: number;
    required?: boolean;
    titlePostfix?: string | null;
    titlePretfix?: string | null;
    relativeField?: string;
    setList?: string[];
    tableHead?: FormField[];
    tabStruct?: TabStruct[];
    hidden?: boolean;
    requiredExpression?: string;
    hiddenExpression?: string;
    readonlyExpression?: string;
    children?: FormField[];
    [key: string]: any;
}
export interface FormExprConfig {
    errorPrompt?: string;
    expr: string;
    exprType: 1 | 2;
    accuracy?: number;
}
